Index: /trunk/src/VBox/Devices/Network/DevVirtioNet.cpp
===================================================================
--- /trunk/src/VBox/Devices/Network/DevVirtioNet.cpp	(revision 56990)
+++ /trunk/src/VBox/Devices/Network/DevVirtioNet.cpp	(revision 56991)
@@ -677,6 +677,5 @@
             break;
         }
-        Log(("%s vnetNetworkDown_WaitReceiveAvail: waiting cMillies=%u...\n",
-                INSTANCE(pThis), cMillies));
+        Log(("%s vnetNetworkDown_WaitReceiveAvail: waiting cMillies=%u...\n", INSTANCE(pThis), cMillies));
         RTSemEventWait(pThis->hEventMoreRxDescAvail, cMillies);
     }
@@ -757,6 +756,5 @@
     if (!memcmp(pThis->config.mac.au8, pvBuf, sizeof(RTMAC)))
         return true;
-    Log4(("%s vnetAddressFilter: %RTmac (conf) != %RTmac (dest)\n",
-          INSTANCE(pThis), pThis->config.mac.au8, pvBuf));
+    Log4(("%s vnetAddressFilter: %RTmac (conf) != %RTmac (dest)\n", INSTANCE(pThis), pThis->config.mac.au8, pvBuf));
 
     for (unsigned i = 0; i < pThis->nMacFilterEntries; i++)
@@ -791,7 +789,6 @@
     if (pGso)
     {
-        Log2(("%s vnetHandleRxPacket: gso type=%x cbHdrsTotal=%u cbHdrsSeg=%u mss=%u"
-              " off1=0x%x off2=0x%x\n", INSTANCE(pThis), pGso->u8Type,
-              pGso->cbHdrsTotal, pGso->cbHdrsSeg, pGso->cbMaxSeg, pGso->offHdr1, pGso->offHdr2));
+        Log2(("%s vnetHandleRxPacket: gso type=%x cbHdrsTotal=%u cbHdrsSeg=%u mss=%u off1=0x%x off2=0x%x\n",
+              INSTANCE(pThis), pGso->u8Type, pGso->cbHdrsTotal, pGso->cbHdrsSeg, pGso->cbMaxSeg, pGso->offHdr1, pGso->offHdr2));
         Hdr.Hdr.u8Flags = VNETHDR_F_NEEDS_CSUM;
         switch (pGso->u8Type)
@@ -894,6 +891,5 @@
         if (RT_FAILURE(rc))
         {
-            Log(("%s vnetHandleRxPacket: Failed to write merged RX buf header: %Rrc\n",
-                 INSTANCE(pThis), rc));
+            Log(("%s vnetHandleRxPacket: Failed to write merged RX buf header: %Rrc\n", INSTANCE(pThis), rc));
             return rc;
         }
@@ -902,6 +898,5 @@
     if (uOffset < cb)
     {
-        Log(("%s vnetHandleRxPacket: Packet did not fit into RX queue (packet size=%u)!\n",
-             INSTANCE(pThis), cb));
+        Log(("%s vnetHandleRxPacket: Packet did not fit into RX queue (packet size=%u)!\n", INSTANCE(pThis), cb));
         return VERR_TOO_MUCH_DATA;
     }
@@ -941,12 +936,10 @@
         if (!uFeatures)
         {
-            Log2(("%s vnetNetworkDown_ReceiveGso: GSO type (0x%x) not supported\n",
-                  INSTANCE(pThis), pGso->u8Type));
+            Log2(("%s vnetNetworkDown_ReceiveGso: GSO type (0x%x) not supported\n", INSTANCE(pThis), pGso->u8Type));
             return VERR_NOT_SUPPORTED;
         }
     }
 
-    Log2(("%s vnetNetworkDown_ReceiveGso: pvBuf=%p cb=%u pGso=%p\n",
-          INSTANCE(pThis), pvBuf, cb, pGso));
+    Log2(("%s vnetNetworkDown_ReceiveGso: pvBuf=%p cb=%u pGso=%p\n", INSTANCE(pThis), pvBuf, cb, pGso));
     int rc = vnetCanReceive(pThis);
     if (RT_FAILURE(rc))
@@ -1151,6 +1144,5 @@
     if ((pThis->VPCI.uStatus & VPCI_STATUS_DRV_OK) == 0)
     {
-        Log(("%s Ignoring transmit requests from non-existent driver (status=0x%x).\n",
-             INSTANCE(pThis), pThis->VPCI.uStatus));
+        Log(("%s Ignoring transmit requests from non-existent driver (status=0x%x).\n", INSTANCE(pThis), pThis->VPCI.uStatus));
         return;
     }
@@ -1174,6 +1166,6 @@
         uHdrLen = sizeof(VNETHDR);
 
-    Log3(("%s vnetTransmitPendingPackets: About to transmit %d pending packets\n", INSTANCE(pThis),
-          vringReadAvailIndex(&pThis->VPCI, &pThis->pTxQueue->VRing) - pThis->pTxQueue->uNextAvailIndex));
+    Log3(("%s vnetTransmitPendingPackets: About to transmit %d pending packets\n",
+          INSTANCE(pThis), vringReadAvailIndex(&pThis->VPCI, &pThis->pTxQueue->VRing) - pThis->pTxQueue->uNextAvailIndex));
 
     vpciSetWriteLed(&pThis->VPCI, true);
@@ -1200,6 +1192,5 @@
             for (unsigned int i = 1; i < elem.nOut; i++)
                 uSize += elem.aSegsOut[i].cb;
-            Log5(("%s vnetTransmitPendingPackets: complete frame is %u bytes.\n",
-                  INSTANCE(pThis), uSize));
+            Log5(("%s vnetTransmitPendingPackets: complete frame is %u bytes.\n", INSTANCE(pThis), uSize));
             Assert(uSize <= VNET_MAX_FRAME_SIZE);
             if (pThis->pDrv)
@@ -1262,7 +1253,6 @@
                                   INSTANCE(pThis), pGso->cbHdrsTotal));
                         }
-                        Log2(("%s vnetTransmitPendingPackets: gso type=%x cbHdrsTotal=%u cbHdrsSeg=%u mss=%u"
-                              " off1=0x%x off2=0x%x\n", INSTANCE(pThis), pGso->u8Type,
-                              pGso->cbHdrsTotal, pGso->cbHdrsSeg, pGso->cbMaxSeg, pGso->offHdr1, pGso->offHdr2));
+                        Log2(("%s vnetTransmitPendingPackets: gso type=%x cbHdrsTotal=%u cbHdrsSeg=%u mss=%u off1=0x%x off2=0x%x\n",
+                              INSTANCE(pThis), pGso->u8Type, pGso->cbHdrsTotal, pGso->cbHdrsSeg, pGso->cbMaxSeg, pGso->offHdr1, pGso->offHdr2));
                         STAM_REL_COUNTER_INC(&pThis->StatTransmitGSO);
                     }
@@ -1323,6 +1313,5 @@
     {
         int rc = TMTimerStop(pThis->CTX_SUFF(pTxTimer));
-        Log3(("%s vnetQueueTransmit: Got kicked with notification disabled, "
-              "re-enable notification and flush TX queue\n", INSTANCE(pThis)));
+        Log3(("%s vnetQueueTransmit: Got kicked with notification disabled, re-enable notification and flush TX queue\n", INSTANCE(pThis)));
         vnetTransmitPendingPackets(pThis, pQueue, false /*fOnWorkerThread*/);
         if (RT_FAILURE(vnetCsEnter(pThis, VERR_SEM_BUSY)))
@@ -1363,5 +1352,5 @@
     pThis->u32i++;
     Log3(("vnetTxTimer: Expired, diff %9d usec, avg %9d usec, min %9d usec, max %9d usec\n",
-            u32MicroDiff, pThis->u32AvgDiff, pThis->u32MinDiff, pThis->u32MaxDiff));
+          u32MicroDiff, pThis->u32AvgDiff, pThis->u32MinDiff, pThis->u32MaxDiff));
 
 //    Log3(("%s vnetTxTimer: Expired\n", INSTANCE(pThis)));
@@ -1422,8 +1411,6 @@
         || pElem->aSegsOut[2].cb < sizeof(nMacs))
     {
-        Log(("%s vnetControlMac: Segment layout is wrong "
-             "(u8Command=%u nOut=%u cb1=%u cb2=%u)\n", INSTANCE(pThis),
-             pCtlHdr->u8Command, pElem->nOut,
-             pElem->aSegsOut[1].cb, pElem->aSegsOut[2].cb));
+        Log(("%s vnetControlMac: Segment layout is wrong (u8Command=%u nOut=%u cb1=%u cb2=%u)\n",
+             INSTANCE(pThis), pCtlHdr->u8Command, pElem->nOut, pElem->aSegsOut[1].cb, pElem->aSegsOut[2].cb));
         return VNET_ERROR;
     }
@@ -1436,6 +1423,6 @@
     if (pElem->aSegsOut[1].cb < nMacs * sizeof(RTMAC) + sizeof(nMacs))
     {
-        Log(("%s vnetControlMac: The unicast mac segment is too small "
-             "(nMacs=%u cb=%u)\n", INSTANCE(pThis), pElem->aSegsOut[1].cb));
+        Log(("%s vnetControlMac: The unicast mac segment is too small (nMacs=%u cb=%u)\n",
+             INSTANCE(pThis), nMacs, pElem->aSegsOut[1].cb));
         return VNET_ERROR;
     }
@@ -1443,6 +1430,5 @@
     if (nMacs > VNET_MAC_FILTER_LEN)
     {
-        Log(("%s vnetControlMac: MAC table is too big, have to use promiscuous"
-             " mode (nMacs=%u)\n", INSTANCE(pThis), nMacs));
+        Log(("%s vnetControlMac: MAC table is too big, have to use promiscuous mode (nMacs=%u)\n", INSTANCE(pThis), nMacs));
         pThis->fPromiscuous = true;
     }
@@ -1468,6 +1454,6 @@
     if (pElem->aSegsOut[2].cb < nMacs * sizeof(RTMAC) + sizeof(nMacs))
     {
-        Log(("%s vnetControlMac: The multicast mac segment is too small "
-             "(nMacs=%u cb=%u)\n", INSTANCE(pThis), pElem->aSegsOut[2].cb));
+        Log(("%s vnetControlMac: The multicast mac segment is too small (nMacs=%u cb=%u)\n",
+             INSTANCE(pThis), nMacs, pElem->aSegsOut[2].cb));
         return VNET_ERROR;
     }
@@ -1475,6 +1461,5 @@
     if (nMacs > VNET_MAC_FILTER_LEN - pThis->nMacFilterEntries)
     {
-        Log(("%s vnetControlMac: MAC table is too big, have to use allmulti"
-             " mode (nMacs=%u)\n", INSTANCE(pThis), nMacs));
+        Log(("%s vnetControlMac: MAC table is too big, have to use allmulti mode (nMacs=%u)\n", INSTANCE(pThis), nMacs));
         pThis->fAllMulti = true;
     }
@@ -1505,7 +1490,6 @@
     if (pElem->nOut != 2 || pElem->aSegsOut[1].cb != sizeof(u16Vid))
     {
-        Log(("%s vnetControlVlan: Segment layout is wrong "
-             "(u8Command=%u nOut=%u cb=%u)\n", INSTANCE(pThis),
-             pCtlHdr->u8Command, pElem->nOut, pElem->aSegsOut[1].cb));
+        Log(("%s vnetControlVlan: Segment layout is wrong (u8Command=%u nOut=%u cb=%u)\n",
+             INSTANCE(pThis), pCtlHdr->u8Command, pElem->nOut, pElem->aSegsOut[1].cb));
         return VNET_ERROR;
     }
@@ -1517,11 +1501,9 @@
     if (u16Vid >= VNET_MAX_VID)
     {
-        Log(("%s vnetControlVlan: VLAN ID is out of range "
-             "(VID=%u)\n", INSTANCE(pThis), u16Vid));
+        Log(("%s vnetControlVlan: VLAN ID is out of range (VID=%u)\n", INSTANCE(pThis), u16Vid));
         return VNET_ERROR;
     }
 
-    Log(("%s vnetControlVlan: uCommand=%u VID=%u\n", INSTANCE(pThis),
-         pCtlHdr->u8Command, u16Vid));
+    Log(("%s vnetControlVlan: uCommand=%u VID=%u\n", INSTANCE(pThis), pCtlHdr->u8Command, u16Vid));
 
     switch (pCtlHdr->u8Command)
@@ -1551,7 +1533,6 @@
         if (elem.nOut < 1 || elem.aSegsOut[0].cb < sizeof(VNETCTLHDR))
         {
-            Log(("%s vnetQueueControl: The first 'out' segment is not the "
-                 "header! (%u < 1 || %u < %u).\n", INSTANCE(pThis), elem.nOut,
-                 elem.aSegsOut[0].cb,sizeof(VNETCTLHDR)));
+            Log(("%s vnetQueueControl: The first 'out' segment is not the header! (%u < 1 || %u < %u).\n",
+                 INSTANCE(pThis), elem.nOut, elem.aSegsOut[0].cb,sizeof(VNETCTLHDR)));
             break; /* Skip the element and hope the next one is good. */
         }
@@ -1559,8 +1540,6 @@
                  || elem.aSegsIn[elem.nIn - 1].cb < sizeof(VNETCTLACK))
         {
-            Log(("%s vnetQueueControl: The last 'in' segment is too small "
-                 "to hold the acknowledge! (%u < 1 || %u < %u).\n",
-                 INSTANCE(pThis), elem.nIn, elem.aSegsIn[elem.nIn - 1].cb,
-                 sizeof(VNETCTLACK)));
+            Log(("%s vnetQueueControl: The last 'in' segment is too small to hold the acknowledge! (%u < 1 || %u < %u).\n",
+                 INSTANCE(pThis), elem.nIn, elem.aSegsIn[elem.nIn - 1].cb, sizeof(VNETCTLACK)));
             break; /* Skip the element and hope the next one is good. */
         }
@@ -1585,6 +1564,5 @@
                     u8Ack = VNET_ERROR;
             }
-            Log(("%s Processed control message %u, ack=%u.\n", INSTANCE(pThis),
-                 CtlHdr.u8Class, u8Ack));
+            Log(("%s Processed control message %u, ack=%u.\n", INSTANCE(pThis), CtlHdr.u8Class, u8Ack));
             PDMDevHlpPCIPhysWrite(pThis->VPCI.CTX_SUFF(pDevIns),
                                   elem.aSegsIn[elem.nIn - 1].addr,