Index: trunk/src/VBox/VMM/VMMR3/HM.cpp
===================================================================
--- trunk/src/VBox/VMM/VMMR3/HM.cpp	(revision 57051)
+++ trunk/src/VBox/VMM/VMMR3/HM.cpp	(revision 57052)
@@ -539,29 +539,29 @@
             {
                 case VERR_UNSUPPORTED_CPU:
-                    pszMsg = "Unknown CPU, VT-x or AMD-v features cannot be ascertained.";
+                    pszMsg = "Unknown CPU, VT-x or AMD-v features cannot be ascertained";
                     break;
 
                 case VERR_VMX_NO_VMX:
-                    pszMsg = "VT-x is not available.";
+                    pszMsg = "VT-x is not available";
                     break;
 
                 case VERR_VMX_MSR_VMX_DISABLED:
-                    pszMsg = "VT-x is disabled in the BIOS.";
+                    pszMsg = "VT-x is disabled in the BIOS";
                     break;
 
                 case VERR_VMX_MSR_ALL_VMX_DISABLED:
-                    pszMsg = "VT-x is disabled in the BIOS for all CPU modes.";
+                    pszMsg = "VT-x is disabled in the BIOS for both all CPU modes";
                     break;
 
                 case VERR_VMX_MSR_LOCKING_FAILED:
-                    pszMsg = "Failed to enable and lock VT-x features.";
+                    pszMsg = "Failed to enable and lock VT-x features";
                     break;
 
                 case VERR_SVM_NO_SVM:
-                    pszMsg = "AMD-V is not available.";
+                    pszMsg = "AMD-V is not available";
                     break;
 
                 case VERR_SVM_DISABLED:
-                    pszMsg = "AMD-V is disabled in the BIOS (or by the host OS).";
+                    pszMsg = "AMD-V is disabled in the BIOS (or by the host OS)";
                     break;
 
@@ -955,24 +955,24 @@
         {
             case VERR_VMX_IN_VMX_ROOT_MODE:
-                return VM_SET_ERROR(pVM, VERR_VMX_IN_VMX_ROOT_MODE, "VT-x is being used by another hypervisor.");
+                return VM_SET_ERROR(pVM, VERR_VMX_IN_VMX_ROOT_MODE, "VT-x is being used by another hypervisor");
             case VERR_VMX_NO_VMX:
-                return VM_SET_ERROR(pVM, VERR_VMX_NO_VMX, "VT-x is not available.");
+                return VM_SET_ERROR(pVM, VERR_VMX_NO_VMX, "VT-x is not available");
             case VERR_VMX_MSR_VMX_DISABLED:
-                return VM_SET_ERROR(pVM, VERR_VMX_MSR_VMX_DISABLED, "VT-x is disabled in the BIOS.");
+                return VM_SET_ERROR(pVM, VERR_VMX_MSR_VMX_DISABLED, "VT-x is disabled in the BIOS");
             case VERR_VMX_MSR_ALL_VMX_DISABLED:
-                return VM_SET_ERROR(pVM, VERR_VMX_MSR_ALL_VMX_DISABLED, "VT-x is disabled in the BIOS for all CPU modes.");
+                return VM_SET_ERROR(pVM, VERR_VMX_MSR_ALL_VMX_DISABLED, "VT-x is disabled in the BIOS for all CPU modes");
             case VERR_VMX_MSR_LOCKING_FAILED:
-                return VM_SET_ERROR(pVM, VERR_VMX_MSR_LOCKING_FAILED, "Failed to lock VT-x features while trying to enable VT-x.");
+                return VM_SET_ERROR(pVM, VERR_VMX_MSR_LOCKING_FAILED, "Failed to lock VT-x features while trying to enable VT-x");
             case VERR_VMX_MSR_VMX_ENABLE_FAILED:
-                return VM_SET_ERROR(pVM, VERR_VMX_MSR_VMX_ENABLE_FAILED, "Failed to enable VT-x features.");
+                return VM_SET_ERROR(pVM, VERR_VMX_MSR_VMX_ENABLE_FAILED, "Failed to enable VT-x features");
             case VERR_VMX_MSR_SMX_VMX_ENABLE_FAILED:
-                return VM_SET_ERROR(pVM, VERR_VMX_MSR_SMX_VMX_ENABLE_FAILED, "Failed to enable VT-x features in SMX mode.");
+                return VM_SET_ERROR(pVM, VERR_VMX_MSR_SMX_VMX_ENABLE_FAILED, "Failed to enable VT-x features in SMX mode");
 
             case VERR_SVM_IN_USE:
-                return VM_SET_ERROR(pVM, VERR_SVM_IN_USE, "AMD-V is being used by another hypervisor.");
+                return VM_SET_ERROR(pVM, VERR_SVM_IN_USE, "AMD-V is being used by another hypervisor");
             case VERR_SVM_NO_SVM:
-                return VM_SET_ERROR(pVM, VERR_SVM_NO_SVM, "AMD-V is not available.");
+                return VM_SET_ERROR(pVM, VERR_SVM_NO_SVM, "AMD-V is not available");
             case VERR_SVM_DISABLED:
-                return VM_SET_ERROR(pVM, VERR_SVM_DISABLED, "AMD-V is disabled in the BIOS.");
+                return VM_SET_ERROR(pVM, VERR_SVM_DISABLED, "AMD-V is disabled in the BIOS");
         }
         return VMSetError(pVM, pVM->hm.s.lLastError, RT_SRC_POS, "HM ring-0 init failed: %Rrc", pVM->hm.s.lLastError);